function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
import React, { useImperativeHandle, forwardRef } from "react";
import classNames from "classnames";
import { getUniqueId } from "@pisell/utils";
var ListComponent = function ListComponent(_ref, ref) {
  var _ref$value = _ref.value,
    value = _ref$value === void 0 ? [] : _ref$value,
    _ref$onChange = _ref.onChange,
    onChange = _ref$onChange === void 0 ? function () {} : _ref$onChange,
    _ref$renderItem = _ref.renderItem,
    renderItem = _ref$renderItem === void 0 ? function () {
      return null;
    } : _ref$renderItem,
    _ref$renderAddButton = _ref.renderAddButton,
    renderAddButton = _ref$renderAddButton === void 0 ? function () {
      return null;
    } : _ref$renderAddButton,
    _ref$createItem = _ref.createItem,
    createItem = _ref$createItem === void 0 ? function (item) {
      return item;
    } : _ref$createItem,
    _ref$maxLength = _ref.maxLength,
    maxLength = _ref$maxLength === void 0 ? 999 : _ref$maxLength,
    _ref$rowKey = _ref.rowKey,
    rowKey = _ref$rowKey === void 0 ? "_id" : _ref$rowKey,
    className = _ref.className,
    style = _ref.style,
    wrapClassName = _ref.wrapClassName;
  var handleAddItem = function handleAddItem(item) {
    if (value.length < maxLength) {
      // 添加新项的逻辑
      onChange([].concat(_toConsumableArray(value), [createItem(_objectSpread(_defineProperty({}, rowKey, getUniqueId()), item))]));
    }
  };
  var handleOnChangeItem = function handleOnChangeItem(item, newValue) {
    onChange(value.map(function (d) {
      if (d[rowKey] === item[rowKey]) {
        return _objectSpread(_objectSpread({}, d), newValue);
      }
      return d;
    }));
  };
  var handleDeleteItem = function handleDeleteItem(current) {
    // 删除选定项的逻辑
    onChange(value.filter(function (item) {
      return item[rowKey] !== current[rowKey];
    }));
  };
  useImperativeHandle(ref, function () {
    return {
      add: handleAddItem,
      delete: handleDeleteItem
    };
  });
  return /*#__PURE__*/React.createElement("div", {
    className: classNames("list-component-wrap", wrapClassName)
  }, /*#__PURE__*/React.createElement("ul", {
    className: classNames("list-component-ul", className),
    style: style
  }, value.map(function (item, index) {
    return renderItem(item, index, handleDeleteItem, handleOnChangeItem);
  })), value.length < maxLength && renderAddButton(handleAddItem));
};
export default /*#__PURE__*/forwardRef(ListComponent);